using System;
using GTA;
using GTA.Native;
using System.Drawing;
using System.Windows.Forms;
using System.Collections.Generic;
using System.Net;
using System.IO;

public class xkcdfps : Script
{
    bool debugmode;
    //https://xkcd.com/873/
    int version = 1;
    int fileversion = 0;
    WebClient wc = new WebClient();
    List<string> xkcdstrings = new List<string>();
    List<int> killedpeds = new List<int>();
    List<string> shown = new List<string>();
    Random rand = new Random();

    public xkcdfps()
    {
        Tick += OnTick;
        try
        {
            debugmode = Game.Player.Name == "ardaozkal";
            if (File.Exists("scripts\\xkcdfile.txt"))
            {
                fileversion = int.Parse(File.ReadAllLines("scripts\\xkcdfile.txt")[0]);
                xkcdstrings.AddRange(File.ReadAllLines("scripts\\xkcdfile.txt"));
                xkcdstrings.Remove(fileversion.ToString());
            }
            else
            {
                File.Create("scripts\\xkcdfile.txt").Close();
                File.WriteAllText("scripts\\xkcdfile.txt", "0" + Environment.NewLine + "Hello you have no xkcdfile, please wait a bit for it to be downloaded, if it doesn't install it, reinstall the mod.");
                fileversion = int.Parse(File.ReadAllLines("scripts\\xkcdfile.txt")[0]);
                xkcdstrings.AddRange(File.ReadAllLines("scripts\\xkcdfile.txt"));
                xkcdstrings.Remove(fileversion.ToString());
            }


            string dwver = wc.DownloadString(@"http://ardaozkal.github.io/xkcdver.html");
            dwver = dwver.Substring(0, dwver.IndexOf("-"));
            string dwver2 = wc.DownloadString(@"http://ardaozkal.github.io/xkcdfilever.html");
            dwver2 = dwver2.Substring(0, dwver2.IndexOf("-"));
            if (dwver != version.ToString())
            {
                UI.Notify("You are using an old version of XKCD FPS mod, please update to latest version thru gta5-mods.com.");
                if (debugmode)
                {
                    UI.Notify("Curver: " + version + " webver: " + dwver + "done");
                }
            }
            if (dwver2 != fileversion.ToString())
            {
                File.WriteAllText("scripts\\xkcdfile.txt", dwver2 + Environment.NewLine + wc.DownloadString(@"http://ardaozkal.github.io/xkcdfile.html").Replace("*", Environment.NewLine));
                xkcdstrings.Clear();
                fileversion = int.Parse(File.ReadAllLines("scripts\\xkcdfile.txt")[0]);
                xkcdstrings.AddRange(File.ReadAllLines("scripts\\xkcdfile.txt"));
                xkcdstrings.Remove(fileversion.ToString());
            }
        }
        catch
        {

        }
    }
    //u_m_m_jesus_01

    void OnTick(object sender, EventArgs e)
    {
        try
        {
            Entity tgent = Game.Player.GetTargetedEntity();
            if (tgent.Exists() && tgent.Model.IsPed && tgent.IsDead && !killedpeds.Contains(tgent.Handle))
            {
                if (debugmode)
                {
                    UI.Notify("Found");
                }
                killedpeds.Add(tgent.Handle);
                if (tgent.Model == "u_m_m_jesus_01")
                {
                    UI.ShowSubtitle("He was a prophet.", 3000);
                }
                else
                {
                    string currentone = xkcdstrings.ToArray()[rand.Next(xkcdstrings.Count)];

                    if (shown.Count == xkcdstrings.Count)
                    {
                        shown.Clear();
                    }
                    while (shown.Contains(currentone) || (((Ped)(tgent)).Gender == Gender.Female && currentone.Contains("[m]")) || (((Ped)(tgent)).Gender == Gender.Male && currentone.Contains("[f]")) )
                    {
                        currentone = xkcdstrings.ToArray()[rand.Next(xkcdstrings.Count)];
                    }

                    currentone = currentone.Replace("[f]", "").Replace("[m]", "");

                    shown.Add(currentone);

                    currentone = (((Ped)tgent).Gender == Gender.Female) ? currentone.Replace("[Gender]", "She").Replace("[gender]", "she").Replace("[GENDER]", "SHE").Replace("[Genders]", "Her").Replace("[GENDERS]", "HER").Replace("[genders]", "her") : currentone.Replace("[Gender]", "He").Replace("[gender]", "he").Replace("[GENDER]", "HE").Replace("[Genders]", "His").Replace("[GENDERS]", "HIS").Replace("[genders]", "his");

                    UI.ShowSubtitle(currentone, 3000);
                }
            }
            else if (debugmode)
            {
                UI.Notify((tgent.Exists().ToString() + tgent.Model.IsPed.ToString() + tgent.IsDead.ToString() + (!killedpeds.Contains(tgent.Handle)).ToString()));
            }
        }
        catch
        {

        }
    }
}

